Package org.springframework.context.annotation

# Enum Class ScopedProxyMode

java.lang.Object
java.lang.Enum<ScopedProxyMode>
org.springframework.context.annotation.ScopedProxyMode

All Implemented Interfaces:
  `Serializable`, `Comparable<ScopedProxyMode>`, `Constable`

public enum ScopedProxyMode extends Enum<ScopedProxyMode>
Enumerates the various scoped-proxy options.

For a more complete discussion of exactly what a scoped proxy is, see the Scoped Beans as Dependencies section of the Spring reference documentation.

Since:
  2.5
Author:
  Mark Fisher
See Also:
  - `ScopeMetadata`

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`DEFAULT`
Default typically equals `NO`, unless a different default has been configured at the component-scan instruction level.
`INTERFACES`
Create a JDK dynamic proxy implementing all interfaces exposed by the class of the target object.
`NO`
Do not create a scoped proxy.
`TARGET_CLASS`
Create a class-based proxy (uses CGLIB).

## Method Summary

Modifier and Type
Method
Description
`static ScopedProxyMode`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static ScopedProxyMode[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### DEFAULT

public static final ScopedProxyMode DEFAULT
Default typically equals `NO`, unless a different default has been configured at the component-scan instruction level.

### NO

public static final ScopedProxyMode NO
Do not create a scoped proxy.

This proxy-mode is not typically useful when used with a non-singleton scoped instance, which should favor the use of the `INTERFACES` or `TARGET_CLASS` proxy-modes instead if it is to be used as a dependency.

### INTERFACES

public static final ScopedProxyMode INTERFACES
Create a JDK dynamic proxy implementing all interfaces exposed by the class of the target object.

### TARGET_CLASS

public static final ScopedProxyMode TARGET_CLASS
Create a class-based proxy (uses CGLIB).

## Method Details

### values

public static ScopedProxyMode[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static ScopedProxyMode valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null